// -----------------------------------------------------------
// Access the URL below to read more about SimpleHtdigest
// https://www.youtube.com/watch?v=7-KlLriSLRs
//

'use strict';

module.exports = SimpleHtdigest;


const fs  = require('fs' );
const md5 = require('md5');

function SimpleHtdigest() {
}


SimpleHtdigest.prototype.save = function(passwordfile, realm, username, password) {
    var hash = md5(username + ':' + realm + ':' + password);
    var outputText;

    if(fs.existsSync(passwordfile)) {
        outputText = fs.readFileSync(passwordfile, 'utf-8');

        if(-1 < outputText.indexOf(username + ':' + realm)) {
            var regex = new RegExp(username + ':' + realm + '.*?\n');
            outputText = outputText.replace(regex, username + ':' + realm + ':' + hash + '\n');
        } else {
            outputText += username + ':' + realm + ':' + hash + '\n';
        }
    } else {
        outputText = username + ':' + realm + ':' + hash + '\n';
    }

    fs.writeFileSync(passwordfile, outputText);

    return username + ':' + realm + ':' + hash + '\n';
}


SimpleHtdigest.prototype.delete = function(passwordfile, realm, username) {
    var outputText;

    if(fs.existsSync(passwordfile)) {
        outputText = fs.readFileSync(passwordfile, 'utf-8');

        if(-1 < outputText.indexOf(username + ':' + realm)) {
            var regex = new RegExp(username + ':' + realm + '.*?\n');
            outputText = outputText.replace(regex, '');
        } else {
            return false;
        }
    } else {
        return false;
    }
    fs.writeFileSync(passwordfile, outputText);

    return username + ':' + realm;
}


SimpleHtdigest.prototype.getHash = function(realm, username, password) {
    var hash = md5(username + ':' + realm + ':' + password);
    return username + ':' + realm + ':' + hash + '\n';
}
